;Farbe 0b00000|000000|00000				
;          rot| grn | blau				
;      0...31 |0..63 |0...31			
.equ	BLACK			= 0x0000
.equ	WHITE			= 0xFFFF

.equ	BLUE			= 0x001F
.equ	RED				= 0xF800
.equ	GREEN			= 0x07E0
.equ	CYAN			= 0x07FF
.equ	MAGENTA			= 0xF81F
.equ	YELLOW			= 0xFFE0



.equ	Display_Xsize					= 128	// in Pixel	(DOT's)	[1..320]
.equ	Display_Ysize					= 128	// in Pixel (DOT's)	[1..256]

.equ	SSD1351_CMD_SETCOLUMN			= 0x15
.equ	SSD1351_CMD_SETROW				= 0x75
.equ	SSD1351_CMD_WRITERAM			= 0x5C
.equ	SSD1351_CMD_READRAM				= 0x5D
.equ	SSD1351_CMD_SETREMAP			= 0xA0
.equ	SSD1351_CMD_STARTLINE			= 0xA1
.equ	SSD1351_CMD_DISPLAYOFFSET		= 0xA2
.equ	SSD1351_CMD_DISPLAYALLOFF		= 0xA4
.equ	SSD1351_CMD_DISPLAYALLON		= 0xA5
.equ	SSD1351_CMD_NORMALDISPLAY		= 0xA6
.equ	SSD1351_CMD_INVERTDISPLAY		= 0xA7
.equ	SSD1351_CMD_FUNCTIONSELECT		= 0xAB
.equ	SSD1351_CMD_DISPLAYOFF			= 0xAE
.equ	SSD1351_CMD_DISPLAYON			= 0xAF
.equ	SSD1351_CMD_PRECHARGE			= 0xB1
.equ	SSD1351_CMD_DISPLAYENHANCE		= 0xB2
.equ	SSD1351_CMD_CLOCKDIV			= 0xB3
.equ	SSD1351_CMD_SETVSL				= 0xB4
.equ	SSD1351_CMD_SETGPIO 		    = 0xB5
.equ	SSD1351_CMD_PRECHARGE2			= 0xB6
.equ	SSD1351_CMD_SETGRAY				= 0xB8
.equ	SSD1351_CMD_USELUT				= 0xB9
.equ	SSD1351_CMD_PRECHARGELEVEL		= 0xBB
.equ	SSD1351_CMD_VCOMH				= 0xBE
.equ	SSD1351_CMD_CONTRASTABC			= 0xC1
.equ	SSD1351_CMD_CONTRASTMASTER		= 0xC7
.equ	SSD1351_CMD_MUXRATIO			= 0xCA
.equ	SSD1351_CMD_COMMANDLOCK			= 0xFD
.equ	SSD1351_CMD_HORIZSCROLL			= 0x96
.equ	SSD1351_CMD_STOPSCROLL			= 0x9E
.equ	SSD1351_CMD_STARTSCROLL			= 0x9F

; ##############################################################################
; ##############################################################################
; ##############################################################################
OLED_TX_CMD_TEMP:
	CS_LOW		; OLED-AKTIV	
	DC_LOW		; DC = 0		
	rcall SPI_TX_TEMP
	DC_HIGH		; DC = 1		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
OLED_INITIALISIERUNG:
	; PORT auf Ausgang						
	sbi (OLED_CS_DDR) ,(OLED_CS_PIN_NR)	
	sbi (OLED_DC_DDR) ,(OLED_DC_PIN_NR)
	sbi (OLED_RES_DDR),(OLED_RES_PIN_NR)
;-------------------------------------------------------------------------------
	call WAIT_100ms
	RES_LOW									; Reset	
	call WAIT_100ms
	RES_HIGH
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_COMMANDLOCK)		; "LOCK"		
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 
	ldi	temp,(0x12)							; (0x12)		
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_COMMANDLOCK)		; "LOCK"		
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 
	ldi	temp,(0xB1)							; (0xB1)		
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_DISPLAYOFF)		; "DISPLAY OFF"	
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_DISPLAYALLOFF)	; "NORMAL DISPLAY ALL OFF"
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_SETCOLUMN)		;"SET COLUMN ADDRESS"		
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 			
	ldi	temp,(0x00)							; (0x00)	Start Address	
	rcall SPI_TX_TEMP 						  	
	ldi	temp,((Display_Xsize)-1)			; (0x7F)	End Address		
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_SETROW)			; "SET ROW ADDRESS"			
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 			
	ldi	temp,(0x00)							; (0x00)Start Address		
	rcall SPI_TX_TEMP 						  	
	ldi	temp,((Display_Ysize)-1)			; (0x7F)End Address			
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_CLOCKDIV)			; "SET CLOCK DIV"			
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 			
	ldi	temp,(0xF1)							; (0xF1) or faster fFRAM by(0xF0)
	rcall SPI_TX_TEMP 						  	
	ldi	temp,(0x7F)							; (0x7F)					
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_SETREMAP)			; "SET REMAP & DATA FORMAT"	
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 			
	ldi	temp,(0x65)							; (0x65)=0 (0x66)=90 (0x77)=180 (0x74)=270 deg
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_STARTLINE)		; "SET DISPLAY START LINE"	
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 			
	ldi	temp,(0x00)							; (0x00)					
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_DISPLAYOFFSET)	; "SET DISPLAY OFFSET"		
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 			
	ldi	temp,(0x00)							; (0x00)					
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_FUNCTIONSELECT)	; "FUNCTIONS SELECTION"		
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 			
	ldi	temp,(0x01)							; (0x00)8-bit [reset](0x01) 16-bit(0x03)18-bit Interface
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_SETVSL)			; "SET SEGMENT LOW VOLTAGE"	
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 			
	ldi	temp,(0xA0)							; A (0xA0)					
	rcall SPI_TX_TEMP 						  	
	ldi	temp,(0xB5)							; B (0xB5)					
	rcall SPI_TX_TEMP 						  	
	ldi	temp,(0x55)							; C (0x55)					
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_CONTRASTABC)		; "SET CONTRAST VALUE FOR EACH PIXEL COLOR" 
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 
	ldi	temp,(255)							; COLOR A (0xC8)		BLUE	200		(138) -> reset
	rcall SPI_TX_TEMP 						  	
	ldi	temp,(255)							; COLOR B (0x80)		GREEN	128		(81)  -> reset
	rcall SPI_TX_TEMP 						  	
	ldi	temp,(255)							; COLOR C (0xC0)		RED		192		(138) -> reset
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_CONTRASTMASTER)	; "SET MASTER CONTRAST"	
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 		
	ldi	temp,(15)							; (0x0F) full power (15)
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_PRECHARGE)		; "SET PRECHARGE PHASE"	
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 		
	ldi	temp,(0x32)							; (0x32) Phase2= 3 DCLK	| Phase1= 5 DCLK
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_DISPLAYENHANCE)	; "SET DISPLAY ENHANCE"	
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 		
	ldi	temp,(0xA4)							; (0xA4)	enhance display performance
	rcall SPI_TX_TEMP 						  	
	ldi	temp,(0x00)							; (0x00)				
	rcall SPI_TX_TEMP 						  	
	ldi	temp,(0x00)							; (0x00)				
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_PRECHARGELEVEL)	; "SET PRE CHARGE LEVEL"
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 		
	ldi	temp,(0x17)							; (0x17) [reset] --> (23 x 0.0125V) + 0.200V = 0.4875V x Vcc
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_PRECHARGE2)		; "SET SECOND PRE CHARGE PERIOD"
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 		
	ldi	temp,(0x01)							; (0x01) --> 1 DCLK		
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_VCOMH)			; "SET VCOMH VOLTAGE"	
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 		
	ldi	temp,(5)							; (0x05) [reset] --> 0.82 x Vcc [0..7] (0.72..0.86)
	rcall SPI_TX_TEMP 						  	
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_NORMALDISPLAY)	;  SSD1351_CMD_INVERTDISPLAY
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 		
;-------------------------------------------------------------------------------
	ldi	temp,(SSD1351_CMD_DISPLAYON)		; "SET DISPLAY ON"		
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
OLED_HOME:
	ldi	temp,(SSD1351_CMD_SETCOLUMN)		;"SET COLUMN ADDRESS"		
	rcall OLED_TX_CMD_TEMP 					; write COMMAND 			

	ldi	temp,(0x00)							; (0x00)	Start Address	
	rcall SPI_TX_TEMP 	

	ldi	temp,((Display_Xsize)-1)			; (0x7F)	End Address		
	rcall SPI_TX_TEMP 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
OLED_CLEAR:
	ldi	temp,(SSD1351_CMD_WRITERAM)			; 
	rcall OLED_TX_CMD_TEMP 						; write COMMAND 		

	ldi ZL,low (128*128)
	ldi ZH,high(128*128)
OLED_CLEAR_s:
	clr temp					;  PIX COLOR H
	rcall SPI_TX_TEMP 						  	
	clr temp					;  PIX COLOR L
	rcall SPI_TX_TEMP 						  	
	sbiw ZL,1
	brne OLED_CLEAR_s

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
OLED_TEST:
	call  WAIT_2s
	rcall OLED_CLEAR
	call  WAIT_1s

	ldi	temp,(SSD1351_CMD_CONTRASTABC)		; "SET CONTRAST VALUE FOR EACH PIXEL COLOR" 
	rcall OLED_TX_CMD_TEMP 						; write COMMAND 
	ldi	temp,(138)							; COLOR A (0xC8)		BLUE	200		(138) -> reset
	rcall SPI_TX_TEMP 						  	
	ldi	temp,(81)							; COLOR B (0x80)		GREEN	128		(81) -> reset
	rcall SPI_TX_TEMP 						  	
	ldi	temp,(192)							; COLOR C (0xC0)		RED		192		(138) -> reset
	rcall SPI_TX_TEMP 						  	
	call  WAIT_1s


	rcall OLED_HOME	

	ldi	temp,(SSD1351_CMD_WRITERAM)			;  write COMMAND 		
  	rcall OLED_TX_CMD_TEMP 					; write COMMAND 		

	ldi ZL,low (128*40)
	ldi ZH,high(128*40)
OLED_TEST_s1:
	ldi temp,high(RED)						;  PIX COLOR H
	rcall SPI_TX_TEMP 						  	
	ldi temp,LOW(RED)						;  PIX COLOR L
	rcall SPI_TX_TEMP 						  	
	sbiw ZL,1
	brne OLED_TEST_s1

	ldi ZL,low (128*40)
	ldi ZH,high(128*40)
OLED_TEST_s2:
	ldi temp,high(GREEN)					;  PIX COLOR H
	rcall SPI_TX_TEMP 						  	
	ldi temp,LOW(GREEN)						;  PIX COLOR L
	rcall SPI_TX_TEMP 						  	
	sbiw ZL,1
	brne OLED_TEST_s2


	ldi ZL,low (128*40)
	ldi ZH,high(128*40)
OLED_TEST_s3:
	ldi temp,high(BLUE)						;  PIX COLOR H
	rcall SPI_TX_TEMP 						  	
	ldi temp,LOW(BLUE)						;  PIX COLOR L
	rcall SPI_TX_TEMP 						  	
	sbiw ZL,1
	brne OLED_TEST_s3
rcall PROGRAMM_STOP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################






