; ##############################################################################
; ##############################################################################
; ##############################################################################
; 16-BIT-TIMER																	
;																				
; CSn2 CSn1 CSn0																
;   0 	0 	0 	No clock source (Timer/Counter stopped).						
;   0 	0 	1 	clkI/O/1 (No prescaling)										
; 	0 	1 	0 	clkI/O/8 (From prescaler)										
; *	0 	1 	1 	clkI/O/64 (From prescaler)										
; 	1 	0 	0 	clkI/O/256 (From prescaler)										
; 	1 	0 	1 	clkI/O/1024 (From prescaler)									
; 	1 	1 	0 	External clock source on Tn pin. Clock on falling edge.			
; 	1 	1 	1 	External clock source on Tn pin. Clock on rising edge.			
;																				
TIMER1_INITIALISIERUNG:
; TIMER-WERTE									
.equ TIMERWERT1				= 65536-31250		;(2 hoch 16 minus....)  => 1s 	
	;  TCCR1B  Timer/Counter 1 Control Register B			
	ldi temp, (0<<ICNC1)| (0<<ICES1)|(0<<WGM13)|(0<<WGM12)|(0<<CS12)|(1<<CS11)|(1<<CS10)
	STS TCCR1B,temp
	; TIMSK1  Timer/Counter1 Interrupt Mask Register		
	ldi temp, (0<<ICIE1)| (0<<OCIE1B)|(0<<OCIE1A)|(1<<TOIE1)
	STS TIMSK1,temp
	; STARTWERT												
	ldi temp,HIGH(TIMERWERT1)
	STS TCNT1H,temp			; HIGH	
	ldi temp,LOW(TIMERWERT1)
	STS TCNT1L,temp			; LOW	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;  1s Takt																		
TIM1_OVF:
	LED_GRUEN_ON
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
	push TEMP1
	push TEMP2
	push TEMP3
	push TEMP4
; ----------------------------------
; Timer Startwert	 				
	ldi temp,HIGH(TIMERWERT1)
	STS TCNT1H,temp			; HIGH	
	ldi temp,LOW(TIMERWERT1)
	STS TCNT1L,temp			; LOW	
; -------------------------------
	rcall ZEIT
; ----------------------------------
	pop TEMP4
	pop TEMP3
	pop TEMP2
	pop TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 				
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
ZEIT:
	LDS temp,(adr_ss10)	; NULL	
	inc temp
	STS (adr_ss10),temp
	cpi temp,10
	brsh ZEIT_ss
	ret	
;-------------------------------------------------------------------------------
ZEIT_ss:
	STS (adr_ss10),NULL	; NULL	

	LDS temp,(adr_ss)
	inc temp
	STS (adr_ss),temp
	cpi temp,60
	brsh ZEIT_mm
	ret	
;-------------------------------------------------------------------------------
ZEIT_mm:
	STS (adr_ss),NULL	; NULL	


	LDS temp,(adr_mm)
	inc temp
	STS (adr_mm),temp
	cpi temp,60
	brsh ZEIT_hh
	ret	
;-------------------------------------------------------------------------------
ZEIT_hh:
	STS (adr_mm),NULL	; NULL	

	LDS temp,(adr_hh)
	inc temp
	STS (adr_hh),temp
	cpi temp,24
	brsh ZEIT_TAG
	ret	
;-------------------------------------------------------------------------------
ZEIT_TAG:
	STS (adr_hh),NULL	; NULL	


	LDS temp,(adr_TAG)
	inc temp
	STS (adr_TAG),temp


	rcall ZEIT_TAGE_MONAT			; OUT: temp1 (Anzahl der Tage im Monat)

	LDS temp,(adr_TAG)

	cp temp, temp1					; VERGLEICH	
	brlo ZEIT_ZAEHLER_TAG_FERTIG	; kleiner => Sprung fertig
	breq ZEIT_ZAEHLER_TAG_FERTIG	; gleich  => SPRUNG fertig
	brsh ZEIT_ZAEHLER_MONAT
ZEIT_ZAEHLER_TAG_FERTIG:
	ret
;													
ZEIT_ZAEHLER_MONAT:
	STS (adr_TAG),EINS

	LDS temp,(adr_MONAT)
	inc temp
	STS (adr_MONAT),temp
	cpi temp,13
	brsh ZEIT_ZAEHLER_JAHR
	ret
;													
ZEIT_ZAEHLER_JAHR:
	STS (adr_MONAT),EINS

	LDS temp,(adr_JAHR)
	inc temp
	STS (adr_JAHR),temp
ret
;###################################################################
;###################################################################
;###################################################################
; OUTPUT: TEMP1 => ANZAHl der TAGE im MONAT							
ZEIT_TAGE_MONAT:
	; MONAT laden	
	LDS temp,(adr_MONAT)

	cpi temp,1					;1
	breq ZEIT_TAGE_MONAT_31
	cpi temp,2					;2
	breq ZEIT_TAGE_MONAT_28
	cpi temp,3					;3
	breq ZEIT_TAGE_MONAT_31
	cpi temp,4					;4
	breq ZEIT_TAGE_MONAT_30
	cpi temp,5					;5
	breq ZEIT_TAGE_MONAT_31
	cpi temp,6					;6
	breq ZEIT_TAGE_MONAT_30
	cpi temp,7					;7
	breq ZEIT_TAGE_MONAT_31
	cpi temp,8					;8
	breq ZEIT_TAGE_MONAT_31
	cpi temp,9					;9
	breq ZEIT_TAGE_MONAT_30
	cpi temp,10					;10
	breq ZEIT_TAGE_MONAT_31
	cpi temp,11					;11
	breq ZEIT_TAGE_MONAT_30
	cpi temp,12					;12
	breq ZEIT_TAGE_MONAT_31
	rjmp ZEIT_TAGE_MONAT_31

ZEIT_TAGE_MONAT_28:
	ldi temp1,28
	ret
ZEIT_TAGE_MONAT_30:
	ldi temp1,30
	ret
ZEIT_TAGE_MONAT_31:
	ldi temp1,31
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

